using BMA.EHR.Extensions;
using BMA.EHR.Recurit.Exam.Service.Controllers;
using BMA.EHR.Recurit.Exam.Service.Services;
using BMA.EHR.Recurit.Exam.Service.Data;
using BMA.EHR.Recurit.Exam.Service.Responses;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Microsoft.EntityFrameworkCore;
using Swashbuckle.AspNetCore.Annotations;
using Telerik.Reporting;
using Telerik.Reporting.Processing;
using BMA.EHR.Recurit.Exam.Service.Response;
using BMA.EHR.Recurit.Exam.Service.Models;

namespace BMA.EHR.Recurit.Exam.Service.Controllers
{
    [Route("api/v{version:apiVersion}/candidate/disable-exam/report")]
    [ApiVersion("1.0")]
    [ApiController]
    [Produces("application/json")]
    [Authorize]
    [SwaggerTag("รายงานข้อมูลการสอบแข่งขัน")]
    public class DisableReportController : BaseController
    {
        #region " Fields "

        private readonly ApplicationDbContext _context;
        private readonly IWebHostEnvironment _hostingEnvironment;
        private readonly IConfiguration _configuration;
        private readonly string space = "ㅤ";

        #endregion

        #region " Constructor and Destructor "

        public DisableReportController(ApplicationDbContext context,
                                       IWebHostEnvironment hostingEnvironment,
                                       IConfiguration configuration,
                                       DisableService disableService)
        {
            this._context = context;
            this._hostingEnvironment = hostingEnvironment;
            this._configuration = configuration;
        }

        #endregion
        private int GetExamCountTes(string citizenId)
        {
            try
            {
                var count = _context.Candidates.AsQueryable()
                                    .Where(x => x.CitizenId == citizenId)
                                    .Count();

                return count;
            }
            catch
            {
                throw;
            }
        }

        #region " Methods "

        /// <summary>
        /// แสดงหนังสือรับรอง
        /// </summary>
        /// <param name="id">รหัสรอบการสอบ</param>
        /// <param name="examId">เลขประจำตัวผู้สมัครสอบ</param>
        /// <param name="type">ชนิดของรายงาน</param>
        /// <returns></returns>
        /// <response code="200">เมื่อแสดงรายงานสำเร็จ</response>
        /// <response code="400">ค่าตัวแปรที่ส่งมาไม่ถูกต้อง</response>
        /// <response code="401">ไม่ได้ Login เข้าระบบ</response>
        /// <response code="500">เมื่อเกิดข้อผิดพลาดในการทำงาน</response>

        [HttpGet("certificate/{type:int}/{id:length(36)}/{examId}")]
        [ProducesResponseType(StatusCodes.Status200OK)]
        [ProducesResponseType(StatusCodes.Status400BadRequest)]
        [ProducesResponseType(StatusCodes.Status401Unauthorized)]
        [ProducesResponseType(StatusCodes.Status500InternalServerError)]
        public async Task<ActionResult<ResponseObject>> GetCertificateReportAsync(Guid id, string examId, int type)
        {
            try
            {
                var data = await _context.Disables.AsQueryable()
                                    .Include(x => x.PeriodExam)
                                    .Where(x => x.PeriodExam.Id == id)
                                    .Where(x => x.ExamId == examId)
                                    .Join(_context.DisableScores.AsQueryable()
                                            .Include(x => x.ScoreImport),
                                            rc => new { rc.PeriodExam.Year, rc.ExamId },
                                            sc => new { sc.ScoreImport.Year, sc.ExamId },
                                            (p, sr) => new
                                            {
                                                ExamID = p.ExamId,
                                                p.CitizenId,
                                                Order = p.PeriodExam.Round,
                                                Year = p.PeriodExam.Year.Value.ToThaiYear(),
                                                FullName = $"{p.Prefix}{p.FirstName} {p.LastName}",
                                                ExamResult = sr == null ? "" : sr.ExamStatus,
                                                EndDate = p.PeriodExam.RegisterEndDate == null ? null : p.PeriodExam.RegisterEndDate.Value.ToThaiFullDate3(),
                                                AuthName = "นายณัฐพงศ์ ดิษยบุตร",
                                                AuthPosition = "หัวหน้าสำนักงาน ก.ก."
                                            })
                                    .FirstOrDefaultAsync();

                var rptFile = Path.Combine(_hostingEnvironment.ContentRootPath, "Report", "Recruit", $"rptCertificate{type}.trdp");

                ReportPackager reportPackager = new ReportPackager();
                Telerik.Reporting.Report? report = null;
                using (var sourceStream = System.IO.File.OpenRead(rptFile))
                {
                    report = (Telerik.Reporting.Report)reportPackager.UnpackageDocument(sourceStream);
                }

                report.DataSource = data;
                System.Collections.Hashtable deviceInfo = new System.Collections.Hashtable();

                InstanceReportSource instanceReportSource = new InstanceReportSource()
                {
                    ReportDocument = report
                };


                ReportProcessor reportProcessor = new ReportProcessor(_configuration);
                RenderingResult result = reportProcessor.RenderReport("PDF", instanceReportSource, deviceInfo);

                var content = result.DocumentBytes;
                return File(content, "application/pdf", $"หนังสือรับรอง_{data.CitizenId}_{data.FullName}.pdf");

            }
            catch (Exception ex)
            {
                return Error(ex, "เกิดข้อผิดพลาดในการแสดงรายงาน");
            }
        }

        /// <summary>
        /// แสดงเอกสารผลสอบ
        /// </summary>
        /// <param name="id">รหัสรอบการสอบ</param>
        /// <param name="examId">เลขประจำตัวผู้สมัครสอบ</param>
        /// <returns></returns>
        /// <response code="200">เมื่อแสดงรายงานสำเร็จ</response>
        /// <response code="400">ค่าตัวแปรที่ส่งมาไม่ถูกต้อง</response>
        /// <response code="401">ไม่ได้ Login เข้าระบบ</response>
        /// <response code="500">เมื่อเกิดข้อผิดพลาดในการทำงาน</response>
        [HttpGet("score/{id:length(36)}/{examId}")]
        [ProducesResponseType(StatusCodes.Status200OK)]
        [ProducesResponseType(StatusCodes.Status400BadRequest)]
        [ProducesResponseType(StatusCodes.Status401Unauthorized)]
        [ProducesResponseType(StatusCodes.Status500InternalServerError)]
        public async Task<ActionResult<ResponseObject>> GetScoreReportAsync(Guid id, string examId)
        {
            try
            {
                var data = await _context.Disables.AsQueryable()
                                    .Include(x => x.PeriodExam)
                                    .Include(x => x.Documents)
                                    .ThenInclude(x => x.DocumentFile)
                                    .Where(x => x.PeriodExam.Id == id)
                                    .Where(x => x.ExamId == examId)
                                    .Join(_context.DisableScores.AsQueryable()
                                            .Include(x => x.ScoreImport),
                                            rc => new { rc.PeriodExam.Year, rc.ExamId },
                                            sc => new { sc.ScoreImport.Year, sc.ExamId },
                                            (p, sr) => new
                                            {
                                                ExamId = p.ExamId,
                                                CitizenId = p.CitizenId,
                                                p.Prefix,
                                                FullName = $"{p.Prefix}{p.FirstName} {p.LastName}",
                                                DateOfBirth = p.DateOfBirth.ToThaiShortDate(),
                                                Gender = p.Gendor,
                                                Degree = p.Educations.First().Degree,
                                                Major = p.Educations.First().Major,
                                                ExamResult = sr == null ? "" : sr.ExamStatus,
                                                University = p.Educations.First().University,
                                                PositionName = p.PositionName,
                                                ExamName = $"{p.PeriodExam.Name} ครั้งที่ {p.PeriodExam.Round}/{p.PeriodExam.Year.Value.ToThaiYear()}",
                                                Number = sr == null ? "" : sr.Number,
                                                // ExamCount = 10,
                                                // ExamCount = GetExamCountTes(p.CitizenId),
                                                ScoreExpire = p.PeriodExam.AnnouncementDate == null ? "" : p.PeriodExam.AnnouncementDate.Value.AddYears(2).ToThaiShortDate(),
                                                FullA = sr == null ? 0 : sr.FullA,
                                                SumA = sr == null ? 0 : sr.SumA,
                                                FullB = sr == null ? 0 : sr.FullB,
                                                SumB = sr == null ? 0 : sr.SumB,
                                                FullC = sr == null ? 0 : sr.FullC,
                                                SumC = sr == null ? 0 : sr.SumC,
                                            })
                                    .FirstOrDefaultAsync();
                var rptFile = Path.Combine(_hostingEnvironment.ContentRootPath, "Report", "Recruit", $"rptExamResult.trdp");
                ReportPackager reportPackager = new ReportPackager();
                Telerik.Reporting.Report report = null;
                using (var sourceStream = System.IO.File.OpenRead(rptFile))
                {
                    report = (Telerik.Reporting.Report)reportPackager.UnpackageDocument(sourceStream);
                }

                report.DataSource = data;
                if (data != null)
                {
                    var _data = new
                    {
                        ExamId = data.ExamId,
                        CitizenId = data.CitizenId,
                        Prefix = data.Prefix,
                        FullName = data.FullName,
                        DateOfBirth = data.DateOfBirth,
                        Gender = data.Gender,
                        Degree = data.Degree,
                        Major = data.Major,
                        ExamResult = data.ExamResult,
                        University = data.University,
                        PositionName = data.PositionName,
                        ExamName = data.ExamName,
                        Number = data.Number,
                        ExamCount = GetExamCountTes(data.CitizenId),
                        ScoreExpire = data.ScoreExpire,
                        FullA = data.FullA,
                        SumA = data.SumA,
                        FullB = data.FullB,
                        SumB = data.SumB,
                        FullC = data.FullC,
                        SumC = data.SumC,
                    };
                    report.DataSource = _data;
                }
                System.Collections.Hashtable deviceInfo = new System.Collections.Hashtable();

                InstanceReportSource instanceReportSource = new InstanceReportSource()
                {
                    ReportDocument = report
                };


                ReportProcessor reportProcessor = new ReportProcessor(_configuration);
                RenderingResult result = reportProcessor.RenderReport("PDF", instanceReportSource, deviceInfo);

                var content = result.DocumentBytes;
                return File(content, "application/pdf", $"ผลคะแนนสอบ_{data.CitizenId}_{data.FullName}.pdf");
            }
            catch (Exception ex)
            {
                return Error(ex, "เกิดข้อผิดพลาดในการแสดงรายงาน");
            }
        }

        #endregion
    }
}
